diff --git a/Chips/Hisilicon/HisiPkg.dec b/Chips/Hisilicon/HisiPkg.dec
index 2c02e14..023d784 100644
--- a/Chips/Hisilicon/HisiPkg.dec
+++ b/Chips/Hisilicon/HisiPkg.dec
@@ -21,6 +21,9 @@
 
 [Includes]
   Include
+  Hi1610/Hi1610AcpiTables/
+  Hi1616/D05AcpiTables/
+  Pv660/Pv660AcpiTables/
 
 [Ppis]
   gIpmiInterfacePpiGuid = {0x28ae4d88, 0xb658, 0x46b9, {0xa0, 0xe7, 0xd4, 0x95, 0xe2, 0xe8, 0x97, 0xf}}
@@ -37,12 +40,25 @@
   gBmcInfoProtocolGuid = {0x43fa6ffd, 0x35e4, 0x479e, {0xab, 0xec, 0x5, 0x3, 0xf6, 0x48, 0x0, 0xf5}}
   gSataEnableFlagProtocolGuid = {0xc2b3c770, 0x8b4a, 0x4796, {0xb2, 0xcf, 0x1d, 0xee, 0x44, 0xd0, 0x32, 0xf3}}
   gPlatformSasProtocolGuid = {0x40e9829f, 0x3a2c, 0x479a, {0x9a, 0x93, 0x45, 0x7d, 0x13, 0x50, 0x96, 0x5d}}
+  gEfiApeiBertProtocolGuid = {0x40e98200, 0x3a2c, 0x479a, {0x9a, 0x93, 0x45, 0x7d, 0x13, 0x50, 0x96, 0x5d}}
+  gEfiApeiHestProtocolGuid = { 0xb3fa54ee, 0x3729, 0x4942, { 0xb5, 0x36, 0x7e, 0xa3, 0xe0, 0x5e, 0xa, 0x8a }}
 
 [Guids]
   gHisiTokenSpaceGuid = {0xc8bc553e, 0x12bf, 0x11e6, {0x97, 0x4f, 0x87, 0xf7, 0x7c, 0xfd, 0x52, 0x1d}}
 
   gHisiEfiMemoryMapGuid  = {0xf8870015, 0x6994, 0x4b98, {0x95, 0xa2, 0xbd, 0x56, 0xda, 0x91, 0xc0, 0x7f}}
   gVersionInfoHobGuid = {0xe13a14c, 0x859c, 0x4f22, {0x82, 0xbd, 0x18, 0xe, 0xe1, 0x42, 0x12, 0xbf}}
+  #
+  # APEI Support
+  #
+  gEfiCperArmProcessorSectionTypeGuid   = { 0xe19e3d16, 0xbc11, 0x11e4, { 0x9c, 0xaa, 0xc2, 0x05, 0x1d, 0x5d, 0x46, 0xb0 }}
+  gEfiCperFirmwareErrorSectionTypeGuid          = { 0x81212a96, 0x09ed, 0x4996, { 0x94, 0x71, 0x8d, 0x72, 0x9c, 0x8e, 0x69, 0xed }}
+  gEfiCperPciBusSectionTypeGuid                 = { 0xc5753963, 0x3b84, 0x4095, { 0xbf, 0x78, 0xed, 0xda, 0xd3, 0xf9, 0xc9, 0xdd }}
+  gEfiCperPciDevSectionTypeGuid                 = { 0xeb5e4685, 0xca66, 0x4769, { 0xb6, 0xa2, 0x26, 0x06, 0x8b, 0x00, 0x13, 0x26 }}
+  gEfiCperPcieSectionTypeGuid                   = { 0xd995e954, 0xbbc1, 0x430f, { 0xad, 0x91, 0xb4, 0x4d, 0xcb, 0x3c, 0x6f, 0x35 }}
+  gEfiCperPlatformMemory2SectionTypeGuid        = { 0x61EC04FC, 0x48E6, 0xD813, { 0x25, 0xC9, 0x8D, 0xAA, 0x44, 0x75, 0x0B, 0x12 }}
+  gEfiCperPlatformMemorySectionTypeGuid         = { 0xa5bc1114, 0x6f64, 0x4ede, { 0xb8, 0x63, 0x3e, 0x83, 0xed, 0x7c, 0x83, 0xb1 }}
+  gEfiCperProcessorGenericSectionTypeGuid       = { 0x9876ccad, 0x47b4, 0x4bdb, { 0xb6, 0x5e, 0x16, 0xf1, 0x93, 0xc4, 0xf3, 0xdb }}
 
 [LibraryClasses]
   PlatformSysCtrlLib|Include/Library/PlatformSysCtrlLib.h
diff --git a/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.depex b/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.depex
new file mode 100644
index 0000000000000000000000000000000000000000..163dbbe18c94d23e0100234e66f0f561bc7c891e
GIT binary patch
diff --git a/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.efi b/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.efi
new file mode 100644
index 0000000000000000000000000000000000000000..6358de232ab07f25291a23aab918e48a418e1fb8
GIT binary patch
diff --git a/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.inf b/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.inf
new file mode 100644
index 0000000..6e51a1d
--- /dev/null
+++ b/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.inf
@@ -0,0 +1,26 @@
+#/** @file
+#
+#    Copyright (c) 2017, Hisilicon Limited. All rights reserved.
+#    Copyright (c) 2017, Linaro Limited. All rights reserved.
+#
+#    This program and the accompanying materials
+#    are licensed and made available under the terms and conditions of the BSD License
+#    which accompanies this distribution. The full text of the license may be found at
+#    http://opensource.org/licenses/bsd-license.php
+#
+#    THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+#    WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+#
+#**/
+
+
+[defines]
+  INF_VERSION                    = 0x00010019
+  BASE_NAME                      = AcpiApei
+  FILE_GUID                      = E4630F5E-EBC2-FD3a-86BB-3CFDC4398C5F
+  MODULE_TYPE                    = UEFI_DRIVER
+  VERSION_STRING                 = 1.0
+
+[Binaries]
+   PE32|AcpiApei.efi|*
+
diff --git a/Platforms/Hisilicon/D03/D03.fdf b/Platforms/Hisilicon/D03/D03.fdf
index ff65af3..6d21ffe 100644
--- a/Platforms/Hisilicon/D03/D03.fdf
+++ b/Platforms/Hisilicon/D03/D03.fdf
@@ -238,6 +238,7 @@ READ_LOCK_STATUS   = TRUE
   INF RuleOverride=ACPITABLE OpenPlatformPkg/Chips/Hisilicon/Hi1610/Hi1610AcpiTables/AcpiTablesHi1610.inf
   INF OpenPlatformPkg/Chips/Hisilicon/Drivers/AcpiPlatformDxe/AcpiPlatformDxe.inf
 
+  INF OpenPlatformPkg/Platforms/Hisilicon/Binary/D03/Drivers/Apei/AcpiApei.inf
   #
   #Network
   #